// Variables and constants for temperature sensor
const int sensorPin = A0;
const float baselineTemp = 20.0;
int sensorVal = 0;
float volts = 0;
float temp = 0;
String info = "";

// Variables and constants for LED diodes
const int led1pin = 2;
const int led2pin = 3;
int led1 = 0;
int led2 = 0;

//Variables and constants for motor
const int motorpin = 9;
int speed = 0;

// Variables for data exchange
String incomingString = ""; // for incoming serial data

// -------------------------------------------------------------------------------------------

void setup() {
  // declare pins to be outputs
  pinMode(led1pin, OUTPUT);
  pinMode(led2pin, OUTPUT);
  pinMode(motorpin, OUTPUT);

  digitalWrite(led1pin,led1);
  digitalWrite(led2pin,led2);
  
  // initiate serical communication
  Serial.begin(9600);
    while (!Serial) {
    ;  // wait for serial port to connect. Needed for native USB port only
  }
}

// -------------------------------------------------------------------------------------------

void loop() {

 // Checks if Node-RED is sending any data to Arduino
  if (Serial.available() > 0) {
    // reads information form Node-RED
    incomingString = Serial.readString();

    // update all parameters and turn on/off led
    SeparatesnSets(incomingString);

    // make a string containing all new information [led1,led2,temp,speed]
    info = digitalRead(led1pin) + String(",") + digitalRead(led2pin) + String(",") + temp + String(",") + speed;

    // replies to Node-RED with updates information
    Serial.println(info);  
  }

  // Calculates temperature from sensor
  sensorVal = analogRead(sensorPin);
  volts = (sensorVal/1024.0)*5.0;
  temp = (volts - 0.5)*100;

}


// Function that seperates string s into array [led1,led2,speed]
void SeparatesnSets(String s){

  // seperates data into variables
  int led1 = s.substring(0,1).toInt();
  int led2 = s.substring(2,3).toInt();
  int speed = s.substring(4,s.end()).toInt();

  // maps speed scale 0-10 to scale 0-255
  speed = map(speed,0,10,0,255);

  // update components with new values
  digitalWrite(led1pin,led1);
  digitalWrite(led2pin,led2);
  analogWrite(motorpin,speed);
}


